Subject: Re: [PATCH] socketcan: add a driver for FlexCAN controllers.

From: Wolfgang Grandegger <[email-masked]>
Date: Fri, 18 Jun 2010 12:33:41 +0200

On 06/18/2010 12:16 PM, Marc Kleine-Budde wrote:
> Wolfgang Grandegger wrote:
>> Hi Hans-Jürgen,
>>
>> On 06/17/2010 12:52 PM, Hans J. Koch wrote:
>>> This adds a driver for FlexCAN based CAN controllers,
>>> e.g. found in Freescale i.MX35 SoCs.
>>>
>>> The original version of this driver was posted by Sascha Hauer in July 2009:
>>> http://kerneltrap.org/mailarchive/linux-netdev/2009/7/29/6251621
>>>
>>> I took this version, added NAPI support, and fixed some problems found
>>> during testing. Well, here is the result. Please review.
>>
>> I briefly browsed the patch and various bits and pieces are missing or
>> not correctly implemented. Marc already pointed out a few of them:
>>
>> - I do not find can_put/get_echo_skb functions in the code. How is
>>   IFF_ECHO supposed to work?
> 
> the driver uses hardware loopback

OK, then

  dev = alloc_candev(sizeof(struct flexcan_priv), 0);

should be used (and TX_ECHO_SKB_MAX removed) in Hans-Jürgens driver.

> 
>> - Support for CAN_CTRLMODE_BERR_REPORTING and do_get_berr_counter()
>>   seems to be missing.
>>
>> - Make use of alloc_can_skb() and alloc_can_err_skb().
> 
> the last two points are already addressed in my version of the driver.

I do not see support for CAN_CTRLMODE_BERR_REPORTING in your driver
(which has nothing to do with do_get_berr_counter).

Wolfgang.